package edu.travel.remote;

import edu.travel.rpc.RPCBaseResponse;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

@FeignClient(name = "upload",path = "/upload")
public interface UploadRemoteController {
    /**
     * 文件是否存在
     * @param md5
     * @return
     */
    @GetMapping("/exits/md5")
    RPCBaseResponse exitsFile(@RequestParam("md5") String md5);

    /**
     * 上传过哪些分片
     * @param md5
     * @return
     */
    @GetMapping("/exits/blob")
    RPCBaseResponse exitsBlob(@RequestParam("md5") String md5);

    /**
     * 上传大文件分片
     * @param file
     * @return
     */
    @PostMapping(value = "/uploadBlob",headers = {"content-type=multipart/form-data"})
    RPCBaseResponse uploadBigFile(@RequestParam("file") MultipartFile file);

    /**
     * 合并大文件
     * @param json
     * @return
     */
    @PostMapping(value = "/mergeFile")
    RPCBaseResponse mergeFile(@RequestBody String json);

    /**
     * 上传小文件
     * @param file
     * @return
     */
    @PostMapping(value = "/upload",headers = {"content-type=multipart/form-data"})
    RPCBaseResponse uploadFile(@RequestParam("file") MultipartFile file);
}
