package edu.travel.commodity.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import edu.travel.commodity.dto.BaseCountryServeDTO;
import edu.travel.commodity.entity.BaseCountryServe;
import edu.travel.commodity.mapper.BaseCountryServeMapper;
import edu.travel.commodity.service.BaseCountryServeService;
import edu.travel.rpc.RPCBaseResponse;
import edu.travel.service.SysServiceImpl;
import org.springframework.stereotype.Service;

@Service
public class BaseCountryServeServiceImpl extends SysServiceImpl<BaseCountryServeMapper, BaseCountryServe> implements BaseCountryServeService {
    @Override
    public RPCBaseResponse<IPage<BaseCountryServe>> getCountryServePage(BaseCountryServeDTO dto) {
        Page<BaseCountryServe> baseCountryServePage = new Page<>(dto.getCurrentPage(), dto.getPageSize());
        IPage<BaseCountryServe> pageLink = super.getPageLink(new LambdaQueryWrapper<BaseCountryServe>(), baseCountryServePage);
        RPCBaseResponse<IPage<BaseCountryServe>> pageRPCPageResponse = new RPCBaseResponse<>(200,"SUCCESS",pageLink);
        return pageRPCPageResponse;
    }
}
