package edu.travel.country.web;
import com.baomidou.mybatisplus.core.metadata.IPage;
import edu.travel.commodity.dto.BaseCountryDto;
import edu.travel.commodity.remote.BaseCountryRemoteController;
import edu.travel.commodity.vo.BaseCountryVo;
import edu.travel.country.entity.BaseCountry;
import edu.travel.country.service.BaseCountryService;
import edu.travel.rpc.RPCBaseResponse;
import edu.travel.web.BaseController;
import org.springframework.beans.BeanUtils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 国家表(base_country)表控制层
 *
 * @author xxxxx
 */
@RestController
@RequestMapping("/baseCountry")
public class BaseCountryController extends BaseController<BaseCountry> implements BaseCountryRemoteController {

    /**
     * 服务对象
     */
    @Autowired
    private BaseCountryService baseCountryService;


    //国家树
    @GetMapping("/getCountryTree")
    public RPCBaseResponse<List<BaseCountryVo>> getCountryTree() {
        return baseCountryService.getCountryTree();
    }

    //国家分页
    @GetMapping("/getCountryPage")
    public RPCBaseResponse<IPage<BaseCountryVo>> getCountryPage(BaseCountryDto baseCountryDTO) {
        return baseCountryService.getCountryPage(baseCountryDTO);
    }

    @Override
    @GetMapping("/getFormId")
    public RPCBaseResponse<BaseCountryVo> getFormId(String id) {
        RPCBaseResponse<BaseCountry> countryRPCBaseResponse = super.getId(id);
        RPCBaseResponse<BaseCountryVo> baseCountryVoRPCBaseResponse = new RPCBaseResponse<>();
        BeanUtils.copyProperties(countryRPCBaseResponse, baseCountryVoRPCBaseResponse);
        return baseCountryVoRPCBaseResponse;
    }

    @Override
    @PostMapping("/updateFormId")
    public RPCBaseResponse<BaseCountryVo> updateTargetFormId(@RequestBody BaseCountryDto entity) {
        BaseCountry baseCountry = new BaseCountry();
        BeanUtils.copyProperties(entity, baseCountry);
        RPCBaseResponse<BaseCountry> baseCountryRPCBaseResponse = super.updateTargetById(baseCountry);
        RPCBaseResponse<BaseCountryVo> baseCountryVoRPCBaseResponse = new RPCBaseResponse<>();
        BeanUtils.copyProperties(baseCountryRPCBaseResponse, baseCountryVoRPCBaseResponse);
        return baseCountryVoRPCBaseResponse;
    }

    @Override
    @PostMapping("/saveForm")
    public RPCBaseResponse<BaseCountryVo> saveFormTarget(@RequestBody BaseCountryDto entity) {
        BaseCountry baseCountry = new BaseCountry();
        BeanUtils.copyProperties(entity, baseCountry);
        RPCBaseResponse<BaseCountry> baseCountryRPCBaseResponse = super.saveTarget(baseCountry);
        RPCBaseResponse<BaseCountryVo> baseCountryVoRPCBaseResponse = new RPCBaseResponse<>();
        BeanUtils.copyProperties(baseCountryRPCBaseResponse, baseCountryVoRPCBaseResponse);
        return baseCountryVoRPCBaseResponse;
    }

    @Override
    @PostMapping("/deleteFormId")
    public RPCBaseResponse<BaseCountryVo> deleteTargetFormId(@RequestBody List<String> ids) {
        RPCBaseResponse<BaseCountry> baseCountryRPCBaseResponse = super.deleteTargetById(ids);
        RPCBaseResponse<BaseCountryVo> baseCountryVoRPCBaseResponse = new RPCBaseResponse<>();
        BeanUtils.copyProperties(baseCountryRPCBaseResponse, baseCountryVoRPCBaseResponse);
        return baseCountryVoRPCBaseResponse;
    }

    @Override
    @GetMapping("/listForm")
    public RPCBaseResponse<List<BaseCountryVo>> getAllForm() {
        RPCBaseResponse<List<BaseCountry>> listRPCBaseResponse = super.listAll();
        RPCBaseResponse<List<BaseCountryVo>> baseCountryVoRPCBaseResponse = new RPCBaseResponse<>();
        BeanUtils.copyProperties(listRPCBaseResponse, baseCountryVoRPCBaseResponse);
        return baseCountryVoRPCBaseResponse;
    }
}
